#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <fstream>
#include <cstring>
#include <cstdlib>
#include <cstdarg>

using namespace std;

#ifndef VALUES_H
#define VALUES_H
#define E 2.718281828
#define CRITICAL 0.05
#define WSIZE 6
#endif
#ifdef _MSC_VER

#define snprintf snprintf
inline int c99_vsnprintf(char* str, size_t size, const char* format, va_list ap)
{
	int count = -1;

	if (size != 0)
		count = _vsnprintf_s(str, size, _TRUNCATE, format, ap);
	if (count == -1)
		count = _vscprintf(format, ap);

	return count;
}
inline int snprintf(char* str, size_t size, const char* format, ...)
{
	int count;
	va_list ap;

	va_start(ap, format);
	count = c99_vsnprintf(str, size, format, ap);
	va_end(ap);

	return count;
}
#endif
int main(int argc, char* argv[]) {
  int rewfasta();
  char a ='x';
  int lth=0;
  int lth1=0;
  int num0=0;
  int num1=0;
  int num2=0;
  char temp[512];
  snprintf(temp, sizeof(temp), "cp %s infile", argv[1]);
  system((char *)temp); // run system call with variables
  rewfasta();
  ifstream myfile ("outfile");
  string line;
  char seq1[5000];
  char seq2[5000];
  char seq3[5000];
  char seq0[5000];
  string name[3];
  if (myfile.is_open()) {
	int linechk=0;
    while (! myfile.eof() ) {
      linechk++;
      getline (myfile,line);
	if(linechk==1){
		name[0]=line;
		}
	else if (linechk==2){
  		lth1=line.size();
		            char* seq1 = (char*)line.c_str();
		seq1[lth1]='\0';
		}
	else if(linechk==3){
		name[1]=line;
		}
	else if (linechk==4){
  		lth1=line.size();
		            char* seq2 = (char*)line.c_str();
		seq2[lth1]='\0';
		}
	else if(linechk==5){
		name[2]=line;
		}
	else if (linechk==6){
  		lth1=line.size();
		            char* seq3 = (char*)line.c_str();
		seq3[lth1]='\0';
		}
	}
	myfile.close();
	}
  else cout << "Unable to open file"; 
  
  int * rew = new int[lth1];
  int * loc = new int[lth1];
  float com;
  for(int i=0;i<lth1;i++){
	if(seq1[i] == '-' || seq2[i] == '-' || seq3[i] == '-')
		continue;
	else if (seq1[i]== seq2[i]&& seq2[i]==seq3[i])
		continue;
	else if (seq1[i]==seq2[i]&& seq1[i]!=seq3[i]){
		rew[lth]=0;
		loc[lth]=i;
		num0++;
		lth++;
		}
	else if (seq1[i]==seq3[i]&& seq1[i]!=seq2[i]){
		rew[lth]=1;
		loc[lth]=i;
		num1++;
		lth++;
		}
	else if (seq3[i]==seq2[i]&& seq1[i]!=seq3[i]){
		rew[lth]=2;
		loc[lth]=i;
		num2++;
		lth++;
		}
	else{
		continue;
		}
	}
  string outgroup;
  int chk;
  if(num0 >= num1 && num0 >= num2){
        outgroup=name[2];
        chk=2;
        }
  else if(num1 >= num0 && num1 >= num2){
        outgroup=name[1];
        chk=1; 
        }
  else{
        outgroup=name[0];
        chk=0; 
        }
ofstream File("3seq.out"); //write to file
  File << "Sequence\tDonor\tstart\tend\tPvalue\tPvalue\n";
 
  
int ** rewloc1=new int*[lth];
for (int i = 0; i < lth; i++)
{
	rewloc1[i] = new int[lth];
}
int ** rewloc2 = new int*[lth];
for (int i = 0; i < lth; i++)
{
	rewloc1[2] = new int[lth];
}
int same=0;
float p0;
float p1;
float p2;
float ** rew1 = new float*[lth];
for (int i = 0; i < lth; i++)
{
	rew1[i] = new float[lth];
}

float* rew1s = new float[lth];
float ** rew2 = new float*[lth];
for (int i = 0; i < lth; i++)
{
	rew2[i] = new float[lth];
}

float * rew2s = new float[lth];
char tmppval[10];
int yx;

int tab1;// all the parameters going to print out
string tab2;
string tab3;
float tab4;
float tab5;
float tab6;
string tab7;
int tabchk=0;

if(chk==2 && num0!=0 && num1!=0 &&num2!=0 ){
        p0=1.0*num0/lth;
        p1=1.0*num1/lth;
        p2=1.0*num2/lth;
        for(int x=0;x<lth;x++){
                if(rew[x] == 1){
                        rew1s[x]=1.0;
                        rewloc1[x][1]=loc[x];
                        rewloc1[x][0]=loc[x];
                        same=0;
                        for( int y=x+1;y<lth;y++){
                                if(rew[y]!=1){
					continue;
					}
				else{
                                        same++;
                                        }
                                if(same <3){
					continue;
					}
			//	yx=y-x;
				float pval (int tmplth, int tmpid, int N, float tmppv);
                                rew1[x][y]=pval(lth,same,y-x,p1);
                                if(same>WSIZE && rew1[x][y] >CRITICAL){
                                        break; 
                                        }
                                if(rew1[x][y]<rew1s[x]){
                                        rew1s[x]=rew1[x][y];
                                        rewloc1[x][1]=loc[y];
                                        }
                                }
                        snprintf(tmppval,  sizeof(tmppval),"%.2e",rew1s[x]);
                        if(rew1s[x]<CRITICAL){
				if(tabchk==1 && tab1==1 && tab5>rewloc1[x][0]+1 && tab6<rew1s[x]){
					continue;
					}
				else if(tabchk==1 && (tab1!=1 || tab5<=rewloc1[x][0]+1)){
					File <<tab2<<"\t"<<tab3<<"\t"<<tab4<<"\t"<<tab5<<"\t"<<tab6<<"\t"<<tab7<<"\n";
					}
				tab1=1;
				tab2=name[0];
				tab3=outgroup;
				tab4=rewloc1[x][0]+1;
				tab5=rewloc1[x][1]+1;
				tab6=rew1s[x];
				tab7=tmppval;
			tabchk=1;
                                }
                        }
                if(rew[x] == 2){
                        rew2s[x]=1.0;
                        rewloc2[x][1]=loc[x];
                        rewloc2[x][0]=loc[x];
                        same=0;
                        for(int y=x+1;y<lth;y++){
                                if(rew[y]!=2){
					continue;
					}
				else{
                                        same++;
                                        }
                                if(same <3){
					continue;
					}
				float pval (int tmplth, int tmpid, int N, float tmppv);
				yx=y-x;
                                rew2[x][y]=pval(lth,same,yx,p2);
                                if(same>WSIZE && rew2[x][y] >CRITICAL){
                                        break; 
                                        }
                                if(rew2[x][y]<rew2s[x]){
                                        rew2s[x]=rew2[x][y];
                                        rewloc2[x][1]=loc[y];
                                        }
                                }
                        snprintf(tmppval, sizeof(tmppval),"%.2e",rew2s[x]);
                        if(rew2s[x]<CRITICAL){
				if(tabchk==1 && tab1==2 && tab5>rewloc2[x][0]+1 && tab6<rew2s[x]){
					continue;
					}
				else if(tabchk==1 && (tab1!=2 || tab5<=rewloc2[x][0]+1)){
					File <<tab2<<"\t"<<tab3<<"\t"<<tab4<<"\t"<<tab5<<"\t"<<tab6<<"\t"<<tab7<<"\n";
					}
				tab1=2;
				tab2=name[1];
				tab3=outgroup;
				tab4=rewloc2[x][0]+1;
				tab5=rewloc2[x][1]+1;
				tab6=rew2s[x];
				tab7=tmppval;
			tabchk=1;
                                }
                        }
                }
        }
if(chk==0 && num0!=0 && num1!=0 &&num2!=0 ){
        p0=1.0*num0/lth;
        p1=1.0*num1/lth;
        p2=1.0*num2/lth;
        for(int x=0;x<lth;x++){
                if(rew[x] == 0){
                        rew1s[x]=1.0;
                        rewloc1[x][1]=loc[x];
                        rewloc1[x][0]=loc[x];
                        same=0;
                        for( int y=x+1;y<lth;y++){
                                if(rew[y]!=0){
					continue;
					}
				else{
                                        same++;
                                        }
                                if(same <3){
					continue;
					}
				float pval (int tmplth, int tmpid, int N, float tmppv);
                                rew1[x][y]=pval(lth,same,y-x,p0);
                                if(same>WSIZE && rew1[x][y] >CRITICAL){
                                        break; 
                                        }
                                if(rew1[x][y]<rew1s[x]){
                                        rew1s[x]=rew1[x][y];
                                        rewloc1[x][1]=loc[y];
                                        }
                                }
                        snprintf(tmppval, sizeof(tmppval),"%.2e",rew1s[x]);
                        if(rew1s[x]<CRITICAL){
				if(tabchk==1 && tab1==1 && tab5>rewloc1[x][0]+1 && tab6<rew1s[x]){
					continue;
					}
				else if(tabchk==1 && (tab1!=1 || tab5<=rewloc1[x][0]+1)){
					File <<tab2<<"\t"<<tab3<<"\t"<<tab4<<"\t"<<tab5<<"\t"<<tab6<<"\t"<<tab7<<"\n";
					}
				tab1=1;
				tab2=name[1];
				tab3=outgroup;
				tab4=rewloc1[x][0]+1;
				tab5=rewloc1[x][1]+1;
				tab6=rew1s[x];
				tab7=tmppval;
			tabchk=1;
                                }
                        }
                if(rew[x] == 1){
                        rew2s[x]=1.0;
                        rewloc2[x][1]=loc[x];
                        rewloc2[x][0]=loc[x];
                        same=0;
                        for(int y=x+1;y<lth;y++){
                                if(rew[y]!=1){
					continue;
					}
				else{
                                        same++;
                                        }
                                if(same <3){
					continue;
					}
				float pval (int tmplth, int tmpid, int N, float tmppv);
				yx=y-x;
                                rew2[x][y]=pval(lth,same,yx,p1);
                                //rew2[x][y]=pval(lth,same,y-x,p1);
                                if(same>WSIZE && rew2[x][y] >CRITICAL){
                                        break; 
                                        }
                                if(rew2[x][y]<rew2s[x]){
                                        rew2s[x]=rew2[x][y];
                                        rewloc2[x][1]=loc[y];
                                        }
                                }
                        snprintf(tmppval, sizeof(tmppval),"%.2e",rew2s[x]);
                        if(rew2s[x]<CRITICAL){
				if(tabchk==1 && tab1==2 && tab5>rewloc2[x][0]+1 && tab6<rew2s[x]){
					continue;
					}
				else if(tabchk==1 && (tab1!=2 || tab5<=rewloc2[x][0]+1)){
					File <<tab2<<"\t"<<tab3<<"\t"<<tab4<<"\t"<<tab5<<"\t"<<tab6<<"\t"<<tab7<<"\n";
					}
				tab1=2;
				tab2=name[2];
				tab3=outgroup;
				tab4=rewloc2[x][0]+1;
				tab5=rewloc2[x][1]+1;
				tab6=rew2s[x];
				tab7=tmppval;
			tabchk=1;
                                }
                        }
                }
        }
if(chk==1 && num0!=0 && num1!=0 &&num2!=0 ){
        p0=1.0*num0/lth;
        p1=1.0*num1/lth;
        p2=1.0*num2/lth;
        for(int x=0;x<lth;x++){
                if(rew[x] == 0){
                        rew1s[x]=1.0;
                        rewloc1[x][1]=loc[x];
                        rewloc1[x][0]=loc[x];
                        same=0;
                        for( int y=x+1;y<lth;y++){
                                if(rew[y]!=0){
					continue;
					}
				else{
                                        same++;
                                        }
                                if(same <3){
					continue;
					}
				float pval (int tmplth, int tmpid, int N, float tmppv);
                                rew1[x][y]=pval(lth,same,y-x,p0);
                                if(same>WSIZE && rew1[x][y] >CRITICAL){
                                        break; 
                                        }
                                if(rew1[x][y]<rew1s[x]){
                                        rew1s[x]=rew1[x][y];
                                        rewloc1[x][1]=loc[y];
                                        }
                                }
                        snprintf(tmppval, sizeof(tmppval),"%.2e",rew1s[x]);
                        if(rew1s[x]<CRITICAL){
				if(tabchk==1 && tab1==1 && tab5>rewloc1[x][0]+1 && tab6<rew1s[x]){
					continue;
					}
				else if(tabchk==1 && (tab1!=1 || tab5<=rewloc1[x][0]+1)){
					File <<tab2<<"\t"<<tab3<<"\t"<<tab4<<"\t"<<tab5<<"\t"<<tab6<<"\t"<<tab7<<"\n";
					}
				tab1=1;
				tab2=name[0];
				tab3=outgroup;
				tab4=rewloc1[x][0]+1;
				tab5=rewloc1[x][1]+1;
				tab6=rew1s[x];
				tab7=tmppval;
			tabchk=1;
                                }
                        }
                if(rew[x] == 2){
                        rew2s[x]=1.0;
                        rewloc2[x][1]=loc[x];
                        rewloc2[x][0]=loc[x];
                        same=0;
                        for(int y=x+1;y<lth;y++){
                                if(rew[y]!=2){
					continue;
					}
				else{
                                        same++;
                                        }
                                if(same <3){
					continue;
					}
				float pval (int tmplth, int tmpid, int N, float tmppv);
				yx=y-x;
                                rew2[x][y]=pval(lth,same,yx,p2);
                                if(same>WSIZE && rew2[x][y] >CRITICAL){
                                        break; 
                                        }
                                if(rew2[x][y]<rew2s[x]){
                                        rew2s[x]=rew2[x][y];
                                        rewloc2[x][1]=loc[y];
                                        }
                                }
                        snprintf(tmppval, sizeof(tmppval),"%.2e",rew2s[x]);
                        if(rew2s[x]<CRITICAL){
				if(tabchk==1 && tab1==2 && tab5>rewloc2[x][0]+1 && tab6<rew2s[x]){
					continue;
					}
				else if(tabchk==1 && (tab1!=2 || tab5<=rewloc2[x][0]+1)){
					File <<tab2<<"\t"<<tab3<<"\t"<<tab4<<"\t"<<tab5<<"\t"<<tab6<<"\t"<<tab7<<"\n";
					}
				tab1=2;
				tab2=name[2];
				tab3=outgroup;
				tab4=rewloc2[x][0]+1;
				tab5=rewloc2[x][1]+1;
				tab6=rew2s[x];
				tab7=tmppval;
			tabchk=1;
                                }
                        }
                }
        }
if(tab6 >0 && tab6<CRITICAL && num0!=0 && num1!=0 &&num2!=0 ){
	File <<tab2<<"\t"<<tab3<<"\t"<<tab4<<"\t"<<tab5<<"\t"<<tab6<<"\t"<<tab7<<"\n";
	}
	File.close();
	system("cat 3seq.out");
	system("rm infile -f");
	system("rm outfile -f");
  return 0;
}

float pval (int tmplth, int tmpid, int N, float tmppv){
	float tmpall=0;
	for(int M=tmpid;M<=N;M++){
		float tmptotal=0;
		float fact(int n); //needs to be defined
		
		tmptotal+=fact(N);
		tmptotal-=fact(M);
		tmptotal-=fact(N-M);
		tmpall+= exp (tmptotal) * pow (tmppv,M) * pow (1-tmppv,N-M);
		}
		tmpall*=(1.0*tmplth/N);
		return (tmpall);
	}
	
float fact(int n) {
	float k;
	if(n==0){
		return(0);
		}
	else {
		k=log(n)+fact(n-1);
		}
	return(k);
}

